/**
 * Copyright h_sakurai ( http://wonderfl.net/user/h_sakurai )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/s1i1
 */

// forked from 9re's Altanativa3D 7.5 test
package {
    import alternativ7.engine3d.containers.ConflictContainer;
    import alternativ7.engine3d.controllers.SimpleObjectController;
    import alternativ7.engine3d.core.Camera3D;
    import alternativ7.engine3d.core.Debug;
    import alternativ7.engine3d.core.MipMapping;
    import alternativ7.engine3d.core.Object3D;
    import alternativ7.engine3d.core.Sorting;
    import alternativ7.engine3d.core.View;
    import alternativ7.engine3d.materials.FillMaterial;
    import alternativ7.engine3d.objects.Sprite3D;
    import alternativ7.engine3d.primitives.Box;
    
    import flash.display.BitmapData;
    import flash.display.Sprite;
    import flash.display.StageAlign;
    import flash.display.StageQuality;
    import flash.display.StageScaleMode;
    import flash.events.Event;
    import flash.events.KeyboardEvent;
    import flash.geom.ColorTransform;
    import flash.system.Capabilities;
    import flash.ui.Keyboard;
    import flash.filters.GlowFilter;
    import flash.display.BlendMode;
    import alternativ7.engine3d.primitives.Plane;
    import alternativ7.engine3d.core.Clipping;
    import alternativ7.engine3d.core.MouseEvent3D;

    [SWF(width = 465, height = 465, frameRate = 60)]
    public class SimpleDemo extends Sprite {
        
        private var camera:Camera3D;
        private var controller:SimpleObjectController;
        private var box:Box = new Box(200, 200, 200, 3, 3, 3);

        public function SimpleDemo() {

            // Camera
            camera = new Camera3D();
            camera.view = new View(480, 480);
            addChild(camera.view);
            camera.z = -400;

            // Camera controller
            controller = new SimpleObjectController(stage, camera, 200, 3);
            
            // Root object
            var container:ConflictContainer = new ConflictContainer();
            container.resolveByAABB = true;
            container.resolveByOOBB = true;

            // Adding
            container.addChild(camera);

            // Box
            var material:FillMaterial = new FillMaterial(0xff8800);
            box.setMaterialToAllFaces(material);
            box.sorting = Sorting.DYNAMIC_BSP;
            box.rotationX = 10;

            container.addChild(box);
            
            addEventListener(Event.ENTER_FRAME, onEnterFrame);
            
        }

        public function onEnterFrame(e:Event = null):void {
            controller.update();
            camera.render();
        }
    }
}
